#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <fcntl.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>

typedef struct
{
    int channel_value;
    int adc_value;
} SAR_ADC_CONFIG_READ;


#define SARADC_IOC_MAGIC                     'a'
#define IOCTL_SAR_INIT                       _IO(SARADC_IOC_MAGIC, 0)
#define IOCTL_SAR_SET_CHANNEL_READ_VALUE     _IO(SARADC_IOC_MAGIC, 1)

int main(void)
{
    int i;
    SAR_ADC_CONFIG_READ  adcCfg;
    adcCfg.channel_value = 0;   //注意：PAD_SAR_GPIO0 = 0 PAD_SAR_GPIO1 = 1 PAD_SAR_GPIO2 = 2

    int fd = open("/dev/sar", O_WRONLY);
    if(fd == -1) {
        int err = errno;
        printf("\n!!! FAILED to open /dev/sar, errno: %d %s\n", err, strerror(err));
        return -1;
    }

    if (ioctl(fd, IOCTL_SAR_INIT, NULL) < 0) {   
        int err = errno;
        printf("\n!!! IOCTL_SAR_INIT FAILED, errno: %d, %s\n", err, strerror(err));
    }

    for (i=0; i < 500; i++)
    {
        if (ioctl(fd, IOCTL_SAR_SET_CHANNEL_READ_VALUE, &adcCfg) < 0) {
            int err = errno;
            printf("\n!!! IOCTL_SAR_SET_CHANNEL_READ_VALUE FAILED, errno: %d, %s\n", err, strerror(err));
        }
        else {
            printf("SAR: get value %04d, 0x%03x \n", adcCfg.adc_value, adcCfg.adc_value);
        }
        usleep(500000);
}

return 0;
}
